//   Version 2008.08.24b, 2009.11,   by Y. Okamoto


#ifndef MyRNKISS_CK
#define MyRNKISS_CK


using namespace System;

namespace MyRNKISS {

/****************************************************************

            This C++ version was translated, 2007.10, 
			             from 
                 the Delphi version, 
      which was written by Yasuharu Okamoto, JWU, 2004.6.

	  The tranlated C++ version was subsequently modified
						  and
				  added needed members.

	 The period of KISS is of order 2 to the 95th power,
		i.e.  order of 10 to the 28th power
                   


                    The KISS Algorithm

              See   C.P.Robert and G.Casella
             "Monte Carlo Statistical Methods"
                 1999, Springer-Verlag
                         Pp. 39-43.

******************************************************************/

	class myrn {
    	private:
			unsigned __int32 i, j, k;

	    public:
			myrn();
			myrn( unsigned __int32 iv, unsigned __int32 jv, unsigned __int32 kv );
		    virtual ~myrn() { }; 

		    unsigned __int32 seek_i(){ return i;};
			unsigned __int32 seek_j(){ return j;};
			unsigned __int32 seek_k(){ return k;};

			double sqr( double x ){
					return x * x;
			}

			void init();
			void init( unsigned __int32 iv, unsigned __int32 jv, unsigned __int32 kv );

			double uni();                             //   0.0 < uni()  <= 1.0
	//		unsigned __int32 iuni();
			double normal();                          //   Standard Normal Distribution
			double normalMS(double m, double s);      //    m : mean,   s : standard deviation  
			void   normalPair( double & n1, double & n2 );   //    pair of independent random numbers of  
			                                                 //             the standard normal distribution 





    };

}

#endif
